' Performative Devices / Display Workshop
' Olaf Val
'------------------------------------------

'$regfile = "m8def.bat"                            'AtMega8-Deklaration
$crystal = 8000000                                ' oscillator calibration byte
'Baud = 19200
Osccal = 158                                      ' Internen Oszillator auf 8MHz ziehen

' Pony Prog Settings Fuse Bits
'  internal RC oscillator  8 Mhz
' (x)  Cksel3        Cksel 0..3 = 0100 = 8MHz
' ( )  Cksel2
' (x)  Cksel1
' (x)  Cksel0
' (x)  SUT0
' ( )  SUT1
' ( )  COPT

'DisplayTreiber
Dim F_s As Bit
Dim F_int As Bit
Dim Bb As Byte
Dim Bl As Byte
Dim Tics As Word
Dim Mx(5) As Byte
Dim Mxa(5) As Byte
Dim Mrow As Byte At &H100
Dim Mcol As Byte At &H101
Dim Midx As Byte At &H102

'RX/TX Kommunikation mit Nachbarn
Dim Tx_error As Byte At &H90
Dim Rx_error As Byte At &H91
Dim P_c_in As Byte At &H92                        ' Portc RX Bits
Dim P_c_in_a As Byte At &H93
Dim Tx_retry As Byte At &H94                      ' anzahl der sendeversuche
Dim F_tx As Byte At &H95                          '  bit 0,1,2,3 = tx Sendeanforderung
Dim Tx_dir As Byte                                ' 1=rechts,2=oben,3=links, 4= unten
Dim Rx_dir As Byte                                ' 1=rechts,2=oben,3=links, 4= unten
Dim Tx_b As Byte                                  ' Sende Byte
Dim Tx_tic As Byte


Const P_oben = 2
Const P_unten = 4
Const P_rechts = 1
Const P_links = 3

Const E_tx_ack0 = 20
Const E_tx_ack1 = 21
Const E_tx_busy = 22
Const E_tx_adr = 23
Const E_tx_ack2 = 24
Const E_rx_adr = 30
Const E_rx_ack1 = 31
Const E_rx_data1 = 32


Config Timer0 = Timer , Prescale = 256

Config Portc = Output
Config Portd = Output
Config Pind.0 = Output
Config Pind.1 = Output
Config Portb = Output

Config Pinc.0 = Input                             ' Pins zur Nachbar Kommunikation
Config Pinc.1 = Input
Config Pinc.2 = Input
Config Pinc.3 = Input

Config Pinb.7 = Output                            'Sound

'Config Pinb.6 = Input                             'AD input (Sensor)
Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc


Declare Sub Receive_nb
Declare Sub Transmit_nb

On Timer0 Tm0isr

Enable Interrupts
Enable Timer0



Midx = 0

Set Portc.0                                       ' enable pullup resistor
Set Portc.1
Set Portc.2
Set Portc.3

Waitms 100

'Timer
Dim Tics1 As Word                                 'aniTimer
Dim Tics2 As Word
Dim Tick As Word
Dim Tick1 As Word
Tics = 0

'ProgrammLoop
Dim Modus As Byte
Modus = 0

'PunkteZeigen
Dim X As Byte
Dim Y As Byte
Dim Yset As Byte
Dim Bb1 As Byte
Dim L As Byte
Dim R As Byte

'Sound
Dim Noise As Word
Dim Noise1 As Word
Dim Noise2 As Word
Dim Noisebit As Bit

'Ad_input
Dim Ad1 As Word
Dim Ad1a As Word
Dim A As Word


'---Intro(
            Print "***********"                   'Ausgabe auf SerialPort
            Print "Wello World"

            Gosub Punkteloeschen

            Mx(1) = 255
            Mx(2) = 255
            Mx(3) = 255
            Mx(4) = 255
            Mx(5) = 255
            Wait 1
            Sound Portb.7 , 100 , 100             'Sound Lnge, Tonhhe

            Mx(1) = 0
            Mx(2) = 28
            Mx(3) = 28
            Mx(4) = 28
            Mx(5) = 0
            Wait 1
            Sound Portb.7 , 200 , 50              'Sound Pulses , Periods

            Gosub Makenois01
            Wait 1
            Gosub Makenois02
            Wait 1

'---)Intro


'---ProgramLoop(
Do
  Tick = Tick + 1
  If Tick > 1000 Then                             'Takt A(
    Tick = 0

    Gosub Punkteloeschen

    Gosub Runningponit

    If Modus = 0 Then
      Gosub Ad_input
    End If
    If Modus = 1 Then
      Gosub Runningponit
    End If

    Gosub Punktezeigen

  End If                                          'Takt A)

Loop
'---)ProgramLoop


'---SubPrograms(
Punkteloeschen:
   Mxa(1) = 0                                     'clear all
   Mxa(2) = 0
   Mxa(3) = 0
   Mxa(4) = 0
   Mxa(5) = 0
Return


Punktezeigen:
    Yset = 6 - Y
    Bb1 = &B10000000
    R = 8 - X
    For L = 1 To R
     Rotate Bb1 , Left , 1
    Next
    Mxa(yset) = Mxa(yset) Or Bb1

    For L = 1 To 5
        Mx(l) = Mxa(l)
    Next
Return


Makenois01:                                       'Rush
   For Noise = 1 To 6000
    If Rnd(3) = 1 Then
      Set Portb.7
    End If
    If Rnd(3) = 1 Then
      Reset Portb.7
    End If
   Next
Return
                                                          'PSSSIIIOOOOOOOO
Makenois02:
   For Noise = 1 To 90000
   Noise1 = Noise1 + 1
    If Noise1 > Noise2 Then
      Noise1 = 0
      Noise2 = Noise2 + 1
      If Noisebit = 1 Then
       Noisebit = 0
       Set Portb.7
      Else
       Noisebit = 1
       Reset Portb.7
      End If
    End If
   Next
Return

Runningponit:                                     'Running Point
    Tick1 = Tick1 + 1                             'Takt B(
    If Tick1 > 100 Then
      Print "900"
      Tick1 = 0
      Y = 1
      X = X + 1
      If X > 7 Then
        X = 1
      End If
    End If                                        ')Takt B
Return

Ad_input:                                         'Sensor
 Ad1 = Getadc(1)
 Ad1a = Ad1 / 29
 Ad1a = Ad1a
 X = 0
 Y = 1
 For A = 1 To Ad1a
   X = X + 1
   If X > 7 Then
     X = 1
     Y = Y + 1
   End If
 Next
 Print Ad1a                                       'Ausgabe auf SerialPort
 If Ad1a < 7 Then
   Modus = 1
 End If
Return

'---)SubPrograms



'---AsemblerCode(
'*********************************************************
Sub Transmit_nb
'
'  ------         ------------          --------------
' TX     |       |            |Startbit|
'        |       |            |50us    |
'         --4ms--              --------   spter hier erweiterung databits
'                |max  |
'                |100us
' ---------------------|        -------------------------
' RX                   |      |         |
'                      | ack  |         | RX Done
'                       -50us-
'

$asm


Tx_start:


      clr      r18                                ' clear error
      sts      {tx_error},r18                     '


      in       r20,pinc                           '  Leitungen Frei ?
      andi     r20,&B00001111                     '
      subi     r20,&B00001111                     ' alle Leitungen
      breq     tx_st01
      ldi      r18,E_tx_busy                      ' Fehler Leitungen Busy
      sts      {tx_error},r18                     '
      rjmp     tx_ex
Tx_st01:
      lds      r20,{tx_dir}                       ' 1..4
      clr      r19                                '
      sec                                         ' set carry
Tx_st02:
      rol      r19                                ' direction bitposition
      dec      r20                                ' in bitmuster wandeln
      brne     tx_st02

      sts      {f_tx},r19                         '
Tx_sb:
      lds      r20,{f_tx}                         ' hole Statusbits ( auf welchem Pin Senden)
      tst      r20
      brne     Tx_s0
      ldi      r18,E_tx_adr                       ' Fehler TX kein Ziel
      sts      {tx_error},r18                     '
      rjmp     tx_ex

Tx_s0:

      rcall    set_iobit_lo                       ' R20 io-pin Bit auf lo


      clr      r20                                ' clear transmit timer
      sts      {tx_tic},r20
Tx_s1:
      lds      r20,{tx_tic}                       '  warte 4 ms , Sendesignal 4ms low
      ldi      r19,2
      cpse     r20,r19
      rjmp     tx_s1


      ldi      r19,&B00001111                     '  alle pins wieder auf hi
      !out     Portc,r19                          '
'      rcall    wait_us_50
      rcall    set_iobits_tri                     ' alle ports wieder auf input

'      rcall    marker         '1



Tx_w_ack:                                         ' innerhalb der nchsten 100us muss auf entspechnedem pin neg Flanke kommen

      in       r20,pinc                           '   pin f_tx ?
      ldi      r19,&B00001111                     '   muss hi sein
      lds      r19,{f_tx}                         '
      and      r20,r19                            '
      brne     tx_w0                              '
      ldi      r18,E_tx_ack0                      '
      sts      {tx_error},r18                     '
      rjmp     tx_ex
Tx_w0:
      ldi      r18,66                             ' Zeitkonstante laden  66*12*.125us = 100us
Tx_w1:
      dec      r18                                ' Zeitberwachung
      brne     tx_w2                              '
      ldi      r18,E_tx_ack1                      '
      sts      {tx_error},r18                     '
      rjmp     tx_ex
Tx_w2:

      in       r20,pinc                           '  fallende Flanke von pin f_tx ?
      ldi      r19,&B00001111                     '
      eor      r20,r19                            '
      lds      r19,{f_tx}                         '
      and      r20,r19                            '
      breq     tx_w1                              '

'      rcall    marker         '2
Tx_w3:
      ldi      r18,66                             ' Zeitkonstante laden  66*12*.125us = 100us
Tx_w4:
      dec      r18                                ' Zeitberwachung
      brne     tx_w5                              '
      ldi      r18,E_tx_ack2                      '
      sts      {tx_error},r18                     '
      rjmp     tx_ex
Tx_w5:

      in       r20,pinc                           '  steigende Flanke von pin f_tx ?
      ldi      r19,&B00001111                     '  50 us RX ack sollte innerhalb von
      lds      r19,{f_tx}                         '  100us kommen
      and      r20,r19                            '
      breq     tx_w4                              '


'      rcall    marker         '3
                              ' ack empfangen > ok
      lds      r20,{f_tx}                         ' bertragung ok
      rcall    set_iobit_lo


      ldi      r18,80                             ' 50 us
      rcall    wait_us
      rcall    set_iobits_tri
      clr      r20                                ' statusbit lschen
      sts      {f_tx},r20

'      rcall    marker
Tx_ex:                                            ' Ende Transmit


      ret
$end Asm
End Sub
'*********************************************************
' setze alle 4 iobits auf rx tristate pullup on
$asm
Set_iobits_tri:
      in       r19,portc                          ' rest von port unverndert lassen
      ori      r19,&B00001111                     ' pullup on
      !out     portc,r19
      in       r19,ddrc                           ' hole alte Port direction
      andi     r19,&B11110000                     ' neue Port direction, verbindungs pins wieder auf Input
      !out     ddrc,r19                           ' setze entspechenden Pin auf Input
      ret
$end Asm
'*********************************************************
' r20 = f_tx setze entsprechenden io pin lo
$asm
Set_iobit_lo:
      in       r19,ddrc                           ' hole alte Port direction
      andi     r20,&B00001111                     ' nur entspechende bits benutzen
      or       r19,r20                            ' neue Port direction
      !out     ddrc,r19                           ' setze entspechenden Pin auf Output


      ldi      r19,&B00001111                     ' reset Port auf entsprechendem bit
      eor      r20,r19                            ' neues Output Bitmuster

      in       r19,portc                          ' rest von port unverndert lassen
      andi     r19,&B11110000                     '
      or       r20,r19
      !out     portc,r20                          'clear Port Bit, ziehe Leitung auf Low
      ret
$end Asm
'*********************************************************
Sub Receive_nb
$asm
      clr      r18                                ' clear error
      clr      r22                                ' rx direction
      sts      {rx_error},r18                     '

      in       r19,ddrc                           ' hole alte Port direction
      andi     r19,&B11110000                     ' neue Port direction, verbindungs pins wieder auf Input
      !out     ddrc,r19                           ' setze entspechenden Pin auf Input


Rx_r11:                                           ' einer der 4 pins low ?
      in       r19,pinc
      andi     r19,&B00001111                     ' nur lower bits
      clr      r20

      rcall    marker

      sbrc     r19,p_oben-1
      rjmp     Rx_r12
      sbr      r20,2
      sbr      r22,p_oben
      rjmp     rx_r16
Rx_r12:
      sbrc     r19,p_unten-1
      rjmp     Rx_r13
      sbr      r20,8
      sbr      r22,p_unten
      rjmp     rx_r16
Rx_r13:
      sbrc     r19,p_rechts-1
      rjmp     Rx_r14
      sbr      r20,1
      sbr      r22,p_rechts
      rjmp     rx_r16
Rx_r14:
      sbrc     r19,p_links-1
      rjmp     Rx_r15
      sbr      r20,4
      sbr      r22,p_links
      rjmp     rx_r16
Rx_r15:
      rjmp     rx_ex

Rx_r16:


Rx_r20:
      in       r19,pinc                           ' wenn alle bit hi dann exit
      ldi      r18,&B00001111                     '
      eor      r19,r18
      andi     r19,&B00001111                     ' nur lower bits
      brne     rx_r20

      cli                                         ' disable interrupt
'      rcall    marker

      rcall    set_iobit_lo                       ' 50 us low impuls zurck
      ldi      r18,80                             ' 50 us
      rcall    wait_us
      rcall    set_iobits_tri

 '     rcall    marker

      ldi      r18,40                             ' 25 us
      rcall    wait_us
'      rcall    marker

      in       r19,pinc                           ' prfen ob korrektes sendebit
      ldi      r18,&B00001111                     ' vorhanden
      eor      r19,r18
      eor      r20,r18

      and      r19,r20                            ' nur sende bits
      breq     rx_30                              ' falsches rx bit ? > error

 '     rcall    marker
      rjmp     rx_ex

Rx_30:
      ldi      r18,E_rx_data1                     '
      sts      {rx_error},r18                     '
      clr      r22                                ' rx_dir=0

Rx_ex:

      sts      {rx_dir},r22
      sei                                         ' enable interrupt
      ret
$end Asm


End Sub
'*********************************************************
Wait_us:


Wait_us_50_1:
      nop
      nop
      dec      r18
      brne     Wait_us_50_1
      ret
$end Asm




'*********************************************************
Marker:
   sbi   portd,0
   nop
   nop
   nop
   nop

      nop
   nop
   nop
   nop

      nop
   nop
   nop
   nop

      nop
   nop
   nop
   nop
   cbi   portd,0
   ret


'*********************************************************
' Timer0 Interrupt Service Routine  2ms
Tm0isr:                                           ' Prescaler 8MHz/256 / 63 8 MHz

Set F_int                                         ' Interrupt Flag

Timer0 = 193                                      ' 256-63= 193 = 2 ms
Incr Tics
Incr Tx_tic
Incr Tics1
Incr Tics2







$asm
   cbi      Portd,2                               ' Alle Sieben Row Leitungen auf Null setzen
   cbi      Portd,3
   cbi      Portd,4
   cbi      Portd,5
   cbi      Portd,6
   cbi      Portd,7
   cbi      Portb,0

   cbi      Portb,1                               ' Alle 5 Column Leitungen auf Null setzen
   cbi      Portb,2
   cbi      Portb,3
   cbi      Portb,4

$end Asm
 If Mcol = 32 Then
      Mcol = 1
      Midx = 0

   End If
   Incr Midx
   If Mcol = 0 Then Mcol = 1
   Shift Mcol , Left , 1

   lds      r16,{mcol}
   !Out Portb , R16

   Mrow = Mx(midx)
$asm

   lds      r16,{Mrow}                            ' Sieben Row-Pins einschalten gemaess Bitmuster

Rr1:
   sbrs     r16,0                                 ' in Variable Mrow
   rjmp     rr2
   sbi      portd,2

Rr2:
   sbrs     r16,1
   rjmp     rr3
   sbi      portd,3
Rr3:
   sbrs     r16,2
   rjmp     rr4
   sbi      portd,4
Rr4:
   sbrs     r16,3
   rjmp     rr5
   sbi      portd,5
Rr5:
   sbrs     r16,4
   rjmp     rr6
   sbi      portd,6
Rr6:
   sbrs     r16,5
   rjmp     rr7
   sbi      portd,7
Rr7:
   sbrs     r16,6

   rjmp     rrx
   sbi      portb,0

Rrx:

$end Asm

Return
'---)AsemblerCode